



/*
Program 21: procplant.sas
*/


* procplant.sas ************;

* directory needs to be changed ;
libname c "/economic/lbd/microdata";
libname d "/rdcprojects/ch/ch01440/data";

** exit rate ************************;

data one (drop = twonaics onesic);
  set d.lbd;

  * sample needs to be restricted ;
  
  age = year - yearmin_firm;
  if firmid = . then delete;
  if emp <= 0 then delete;
  if emp = . then delete;
  if year = . then delete;
  dind2 = floor(sic/100);
  if year > 2001 then dind2 = floor(naics/1000);
run;

proc sort data=one; by year firmid;
run;

** aggregate to firm level ************************************************;
proc means data=one noprint; by year firmid;
  var emp;
  output out=two mean=;
run;   * age is maximum age of plant within a firm;

data two;
 set two;
 nplant = _freq_;
run;

proc means data=two noprint;
  by year;
  var nplant;
output out=two mean=plant std=sdplant;
run;

proc print data=two;
  var year plant sdplant;
run;

* end procplant.sas;
