/*
Program 2: readlbd1.sas
*/


* readlbd1.sas

* directory structure may need to be changed;
libname c "/economic/lbd/microdata";
libname d "/rdcprojects/ch/ch01440/data";

data one (keep=firmid lbdnum cfn bestnaics bestsic state county emp pay yr zip mu firstyear lastyear);
set

c.lbd1976c
c.lbd1977c
c.lbd1978c
c.lbd1979c
c.lbd1980c
c.lbd1981c
c.lbd1982c
c.lbd1983c
c.lbd1984c
c.lbd1985c
c.lbd1986c
c.lbd1987c
c.lbd1988c
c.lbd1989c
;


if emp = . then delete;
if emp = 0 then delete;

run;

data two (keep=firmid lbdnum cfn bestnaics bestsic state county emp pay yr zip mu firstyear lastyear);
set
c.lbd1990c
c.lbd1991c
c.lbd1992c
c.lbd1993c
c.lbd1994c
c.lbd1995c
c.lbd1996c
c.lbd1997c
c.lbd1998c
c.lbd1999c
c.lbd2000c
c.lbd2001c
c.lbd2002c

;

if emp = . then delete;
if emp = 0 then delete;

run;

data three (keep=firmid lbdnum cfn bestnaics bestsic state county emp pay yr zip mu firstyear lastyear);
set
c.lbd2003c
c.lbd2004c
c.lbd2005c
c.lbd2006c
c.lbd2007c
c.lbd2008c
c.lbd2009c
c.lbd2010c
c.lbd2011c
c.lbd2012c
c.lbd2013c

;

if emp = . then delete;
if emp = 0 then delete;

run;

data lbdtemp (drop=yr cfn firmid bestnaics bestsic firstyear lastyear);
  set one two three ;
  naics = substr(bestnaics,1,6)*1;
  sic = substr(bestsic,1,4)*1;
  year = yr;
  firmid3 = firmid*1;
  nofirmid = 0;
  if firmid3 = . then nofirmid = 1;
  if (firmid3 = .) AND (mu=0) then firmid3 = cfn*1;
  if (firmid3 = .) and (mu=1) then firmid3 = substr(cfn,1,6)*1000;
run;

data lbdtemp (drop=firmid3);
  set lbdtemp;
  firmid = firmid3;
  count = 1;
run;

** check for single owners ********************************************************;
data id;
  set lbdtemp (keep=year lbdnum firmid count);
  if firmid = . then delete;
run;  * id is list of all observations;

* proc export data=id outfile="/rdcprojects/ch/ch01440/data/lbdid.dta" replace;

proc sort data=id; by lbdnum firmid;
run;

proc means data=id noprint;
  var count;
  by lbdnum firmid;
  output out=firm sum=nfirm;
run; * nobs per plant-firm - unit of obs is lbdnum firmid;

data firm;
  set firm;
  count = 1;
run;

proc sort data=firm; by lbdnum;

proc means data=firm noprint;
  var count;
  by lbdnum;
  output out=firm sum=nfirm;
run; * number of firmids per lbdnum - unit of obs is lbdnum;


data firm (keep = lbdnum singleowner);
  set firm;
  singleowner = 0;
  if nfirm = 1 then singleowner = 1;
run;  * count = 1 are firms with only one owner;

proc sort data=firm; by lbdnum;

proc sort data=lbdtemp; by lbdnum;

data d.lbdtemp;
  merge lbdtemp firm; by lbdnum;
run;
** lbdtemp now has variable singeowner which identifies plants that stay with one owner *****************;

/*
proc sort data=d.lbdtemp; by year;

proc means data=d.lbdtemp;
  var singleowner;
  by year;
run;
*/

* end readlbd1.sas;
