
/*
Program 3: readlbd2.sas
*/


* readlbd2.sas;

* libname c "/economic/lbd/microdata";
* libname d "/rdcprojects/ch/ch01440/data";

* library c is not used in this sas file and the directory structure of raw lbd data has changed;

* may need to change directory;

libname d "/projects/data";

** naics to sic  *******************************************************************;
* proc import out=naics datafile = "/rdcprojects/ch/ch01440/data/naics_to_sic.csv" dbms=csv replace;
proc import out=naics datafile = "/projects/data/naics_to_sic.csv" dbms=csv replace;
  getnames = yes;
run;

proc contents;

data naics (drop=sic);
  set naics;
  if naics < XXXXXX then naics = naics*10;
  sic2 = sic;
  if naics = . then delete;
  naicstwo = floor(naics/10000);
  sictwo = floor(sic2/100);
run;

proc sort; by sictwo;

proc means noprint; by sictwo;
  var naicstwo;
output out=sictwo mode=;
run;

proc sort data=sictwo; by sictwo;
run;  * sictwo has two digit sic codes with naics two digit codes;
* variables are sictwo and naicstwo;

data naics (keep = naics sic2);
  set naics;
run;  * variables are naics and sic2;

proc sort data=naics; by naics;
run;  * naics has six digit naics codes with four digit sic codes;

** sic to naics *******************************************************************;
* proc import out=sic datafile = "/rdcprojects/ch/ch01440/data/sic_to_naics.csv" dbms=csv replace;
proc import out=sic datafile = "/projects/data/sic_to_naics.csv" dbms=csv replace;
  getnames = yes;
run;

data sic (drop=naics);
  set sic;
  if naics < XXXXXX then naics = naics*10;
  naics2 = naics;
  if sic = . then delete;
run;

proc sort; by sic;
* sic has four digit sic codes matched to six digit naics;
* variables are sic and naics2;

** end of naics to sic and sic to naics ********************************************;

** merge naics and sic onto lbd  *******************************************************;

data lbdtemp;
  set d.lbdtemp;
  if firmid = . then delete;
;

proc sort data=lbdtemp;
by naics;

data lbd;
  merge lbdtemp naics; by naics;
  if year = . then delete;
  naicstwo = floor(naics/10000);
  sictwo = floor(sic/100);
  * note, naics is original six digit naics, sic is original four digit sic code;
  * sic2 is new two digit six code;
run;

data lbdnonaics (drop=naicstwo);
  set lbd;
  if naics = .;
run;
* lbdnonaics only has sic code;

proc sort data=lbdnonaics; by sictwo;

data lbdnonaics;
  merge lbdnonaics sictwo; by sictwo;
run;

data lbdnaics;
  set lbd;
  if naics = . then delete;
run;

data lbd;
  set lbdnaics lbdnonaics;
run;

proc means data=lbd;
  var naicstwo sictwo;
run;

proc sort data=lbd;
by sic;

data lbd;
  merge lbd sic; by sic;
  if year = . then delete;
run;

** lbd now has naics2 as substitute naics codes ****************;


** create max and min year of firm *********************;
proc sort data=lbd; by firmid;

proc means data=lbd noprint;
  var year; by firmid;
  output out=databs max=yearmax_firm min=yearmin_firm;

proc sort data=lbd; by firmid;

data lbd (drop = _FREQ_ _TYPE_);
  merge lbd databs; by firmid;
run;

** end min and max year ********************************;

** create max and min year of lbdnum *********************;
proc sort data=lbd; by lbdnum;

proc means data=lbd noprint;
  var year; by lbdnum;
  output out=databs max=yearmax_lbdnum min=yearmin_lbdnum;
run;

proc means;

data lbd (drop = _FREQ_ _TYPE_);
  merge lbd databs; by lbdnum;
run;
** end min and max year of lbdnum *************************;

** max and min year by lbdnum - firm **********************;
proc sort data=lbd; by lbdnum firmid;

proc means data=lbd noprint;
  var year; by lbdnum firmid;
  output out=databs max=yearmax_lbdfirm min=yearmin_lbdfirm;
run;

proc means;

data d.lbd (drop = _FREQ_ _TYPE_ state2 county2 state county);
  merge lbd databs; by lbdnum firmid;
  state2 = state*1;
  county2 = county*1;
  fips = state2*1000 + county2;
run;
** max and min year by lbdnum - firm **********************;

proc means;

* end readlbd2.sas ;
