
/*
Program 4: readprod.sas
*/


* readprod.sas  *************;

* directory structure may need to be changed;

libname c "/economic/cmf/microdata";
libname d "/rdcprojects/ch/ch01440/data";


data d1963;
  set c.cmf1963prod;
run;

data d1967;
  set c.cmf1967prod;
run;

data d1972;
  set c.cmf1972prod;
run;

data d1977;
  set c.cmf1977prod;
run;

data d1982;
  set c.cmf1982prod;
run;

data d1987;
  set c.cmf1987prod;
run;

data d1992;
  set c.cmf1992prod;
run;

data d1997;
  set c.cmf1997prod;
run;

data d2002;
  set c.cmf2002prod;
run;

data d2007;
  set c.cmf2007prod;
run;

data d2012;
  set c.cmf2012prod_ind;
run;

data one (keep = curpc pcol ppn pqit pv tvpsd year newid);
  set d1963 d1967 d1972 d1977 d1982 d1987 d1992 d1997;
  curpc = put(curpc,10.);
  balance = substr(curpc,7);
  If balance = 'N' then delete;
  if balance = 'P' then delete;
  if balance = '+' then delete;
  if balance = '-' then delete;
  newid = ppn;
  pcol = put(pcol,7.);
run;

data one (drop=curpc pcol);
  set one;
  length ind $10;
  ind = pcol;
  if pv = . then delete;
  if pv < 0 then delete;
run;

proc contents;

data two (keep = ind survu_id pv tvpsd year);  * after 2002 plant id is survu_id and industry code is naicspc;
  set d2002 d2007 d2012;
  ind = naicspc_col;
  if pv = . then delete;
  if pv < 0 then delete;
run;

proc contents;

proc sort; by survu_id;

data id;  * this is based on  2002 crosswalk of ppn and survu_id created in readcmf.sas ;
  set d.id;
  if ppn = . then delete;  * restrict sample only to ones with legppn;
run;

proc sort data=id; by survu_id;

data two (drop = _type_ _freq_);
  merge two id; by survu_id;
  newid = ppn;
  if ppn = . then newid = survu_id;
  if pv = . then delete;
run;

data d.cmfprod;
  set one two;
run;

proc export data=d.cmfprod outfile="/rdcprojects/ch/ch01440/data/cmfprod.dta" replace;
run;

** number of products *********************;
proc sort; by year ind;

proc means noprint;
  by year ind;
  var pv;
  output out=bs sum=;
run;

proc means data=bs; by year;

** number of establishments ***************;
proc sort data=d.cmfprod; by year newid;

proc means noprint;
  by year newid;
  var pv;
  output out=bs sum=;
run;

proc means data=bs; by year;

**** end readprod.sas;




