
/*
Program 23: replicate2.sas
*/


* replicate2.sas;

* directory needs to be modified;

libname c "/economic/lbd/microdata";
libname d "/rdcprojects/ch/ch01440/data";
%let y = 1984;
* creates firm ids for replication file;

** exit rate ************************;

data two (keep=firmid emp);
  set d.lbd;
  if year = 1983 or year = 1988 or year = 1993 or year = 1998 or year = 2001 or year = 2003 or year = 2008 or year = 2013;
  twonaics=floor(naics/1000);

  * sample needs to be restricted ;

  age = year - yearmin_firm;
  if firmid = . then delete;
  if emp <= 0 then delete;
  if emp = . then delete;
  if year = . then delete;
  dind2 = floor(sic/100);
  if year > 2001 then dind2 = floor(naics/1000);
run;

proc sort data=two; by firmid;
run;

proc means data=two noprint;
  by firmid;
  var emp;
output out=firmid(keep=firmid) sum=;

%macro sample;

%do i=1 %to 20;
proc surveyselect data=firmid out=d.firmid&i
  method = urs
  samprate = 1
  outhits
  rep = 50;
run;
%end;
%mend sample;

%sample;

* end replicate2.sas ******;


